Option Explicit On

Imports System.Runtime.InteropServices
Imports System.Text
Imports System.Timers

Friend Class Form1
    Inherits System.Windows.Forms.Form

    Public p2phandle As IntPtr
    Dim TickCounter As Integer

    'public static, so they are not destroyed by GC
    Dim MyForwardOpenEvent As P2P_ForwardOpenEvent
    Dim MyLinkDoneEvent As P2P_LinkDoneEvent
    Dim MyForwardCloseEvent As P2P_ForwardCloseEvent
    Dim MyStoppedEvent As P2P_StoppedEvent
    Dim MyTextReceivedEvent As P2P_TextReceivedEvent
    Dim MySearchDoneEvent As P2P_SearchDoneEvent
    Dim MyStateChangedEvent As P2P_StateChangeEvent
    Dim MyUserConnectedEvent As P2P_UserConnectedEvent
    Dim MyUserDisconnectedEvent As P2P_UserDisconnectedEvent
    Dim MyPingEvent As P2P_PingEvent

    Dim MyFileDoneEvent As P2P_FileDoneEvent
    Dim MyFireProgressEvent As P2P_FileProgressEvent
    Dim MyFileReceiveEvent As P2P_FileReceiveEvent


    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        If p2phandle <> 0 Then
            P2P_Destroy(p2phandle)
        End If

        'let's enumerate all forms
        If Application.OpenForms.Count = 0 Then
            Application.Exit()
        End If

    End Sub

    Private Sub btnSearch_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnSearch.Click

        TickCounter = 0

        P2P_SetMediatorAddress(p2phandle, "mediator.weonlydo.com")
        P2P_SetMediatorPort(p2phandle, 8002)
        P2P_SetPeerName(p2phandle, txtPeerName.Text)
        P2P_Search(p2phandle, Nothing)

        AddToList("Searching for " & txtPeerName.Text)
    End Sub

    Private Sub btnConnect_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnConnect.Click
        P2P_Link(p2phandle, Text6.Text)
    End Sub

    Private Sub btnSend_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnSend.Click
        P2P_SendText(p2phandle, 1, Text5.Text, True)
    End Sub

    Private Sub btnAdd_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnAdd.Click
        Dim e As Integer
        Dim buffer As New StringBuilder(512)

        Dim forwhandle As IntPtr
        forwhandle = P2P_GetForward(p2phandle, 1)

        P2PForward_SetForwardType(forwhandle, P2P_ForwardTypes.TCPLocalListen)
        P2PForward_SetLocalAddress(forwhandle, Text7.Text)
        P2PForward_SetLocalPort(forwhandle, CInt(Text8.Text))
        P2PForward_SetRemoteAddress(forwhandle, Text9.Text)
        P2PForward_SetRemotePort(forwhandle, CInt(txtMyName0.Text))

        e = P2P_StartForward(p2phandle, 1)
        If e <> 0 Then
            P2P_ErrorText(p2phandle, e, buffer)
            MsgBox(buffer)
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            p2phandle = P2P_Create()
        Catch ex As Exception
            MsgBox("Please check for devP2P.DLL path in devP2P.vb", MsgBoxStyle.OkOnly, "Failed to load devP2P.dll")
            Application.Exit()
            Exit Sub
        End Try

        MyForwardOpenEvent = New P2P_ForwardOpenEvent(AddressOf P2P_ForwardOpenEventImpl)
        MyLinkDoneEvent = New P2P_LinkDoneEvent(AddressOf P2P_LinkDoneEventImpl)
        MyForwardCloseEvent = New P2P_ForwardCloseEvent(AddressOf P2P_ForwardCloseEventImpl)
        MyStoppedEvent = New P2P_StoppedEvent(AddressOf P2P_StoppedEventImpl)
        MyTextReceivedEvent = New P2P_TextReceivedEvent(AddressOf P2P_TextReceivedEventImpl)
        MySearchDoneEvent = New P2P_SearchDoneEvent(AddressOf P2P_SearchDoneEventImpl)
        MyStateChangedEvent = New P2P_StateChangeEvent(AddressOf P2P_StateChangeEventImpl)
        MyUserConnectedEvent = New P2P_UserConnectedEvent(AddressOf P2P_UserConnectedEventImpl)
        MyUserDisconnectedEvent = New P2P_UserDisconnectedEvent(AddressOf P2P_UserDisconnectedEventImpl)
        MyFileDoneEvent = New P2P_FileDoneEvent(AddressOf P2P_FileDoneEventImpl)
        MyFireProgressEvent = New P2P_FileProgressEvent(AddressOf P2P_FileProgressEventImpl)
        MyFileReceiveEvent = New P2P_FileReceiveEvent(AddressOf P2P_FileReceiveEventImpl)
        MyPingEvent = New P2P_PingEvent(AddressOf P2P_PingEventImpl)


        P2P_RegisterForwardOpenEvent(p2phandle, MyForwardOpenEvent)
        P2P_RegisterForwardCloseEvent(p2phandle, MyForwardCloseEvent)
        P2P_RegisterLinkDoneEvent(p2phandle, MyLinkDoneEvent)
        P2P_RegisterStoppedEvent(p2phandle, MyStoppedEvent)
        P2P_RegisterTextReceivedEvent(p2phandle, MyTextReceivedEvent)
        P2P_RegisterSearchDoneEvent(p2phandle, MySearchDoneEvent)
        P2P_RegisterStateChangeEvent(p2phandle, MyStateChangedEvent)
        P2P_RegisterUserConnectedEvent(p2phandle, MyUserConnectedEvent)
        P2P_RegisterUserDisconnectedEvent(p2phandle, MyUserDisconnectedEvent)
        P2P_RegisterFileDoneEvent(p2phandle, MyFileDoneEvent)
        P2P_RegisterFileProgressEvent(p2phandle, MyFireProgressEvent)
        P2P_RegisterFileReceiveEvent(p2phandle, MyFileReceiveEvent)
        P2P_RegisterPingEvent(p2phandle, MyPingEvent)




        EnableButtons()

        Dim buffer As New StringBuilder(512)
        P2P_GetVersion(p2phandle, buffer)
        AddToList("devP2P VERSION " + buffer.ToString)

    End Sub

    Private Delegate Sub EnableButtonsDelegate()
    Private Sub EnableButtons()

        Dim state As Integer

        If List1.InvokeRequired Then
            List1.BeginInvoke(New EnableButtonsDelegate(AddressOf EnableButtons))
        Else

            Timer1.Enabled = False
            TickCounter = 0
            btnConnect.BackColor = Color.Transparent
            btnSearch.BackColor = Color.Transparent
            state = P2P_GetState(p2phandle)

            If state > 0 Then
                ' started
                txtMyName.Enabled = False
                txtPassword.Enabled = False
                txtPeerName.Enabled = False

                btnStart.Enabled = False
                btnStop.Enabled = True

                If state > 4 Then
                    ' connected
                    btnConnect.Enabled = False
                    btnSend.Enabled = True
                    btnAdd.Enabled = True
                    btnSearch.Enabled = False
                Else
                    If Text6.Text <> "" Then
                        btnConnect.Enabled = True
                    Else
                        btnConnect.Enabled = False
                    End If
                    btnSend.Enabled = False
                    btnAdd.Enabled = False
                    btnSearch.Enabled = True
                End If
            Else

                txtMyName.Enabled = True
                txtPassword.Enabled = True
                txtPeerName.Enabled = True

                btnStart.Enabled = True
                btnStop.Enabled = False
                btnConnect.Enabled = False
                btnSend.Enabled = False
                btnAdd.Enabled = False
                btnSearch.Enabled = False
            End If


        End If
    End Sub

    Public Sub AddToList(ByVal RefText As String)
        If List1.InvokeRequired Then
            List1.BeginInvoke(New Action(Of String)(AddressOf AddToList), RefText)
        Else
            List1.Items.Add(RefText)
            List1.SelectedIndex = List1.Items.Count - 1
            List1.SelectedIndex = -1
        End If
    End Sub

    Private Sub Text6_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Text6.TextChanged
        EnableButtons()
    End Sub

    Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick

        ' not important code.. just to flash buttons
        ' to lead you the way...
        If Text6.Text <> "" Then
            If btnConnect.BackColor = Color.Transparent Then
                btnConnect.BackColor = Color.DarkGray
            Else
                btnConnect.BackColor = Color.Transparent
            End If
        Else
            If btnSearch.BackColor = Color.Transparent Then
                btnSearch.BackColor = Color.DarkGray
            Else
                btnSearch.BackColor = Color.Transparent
            End If
        End If

        TickCounter = TickCounter + 1
        If TickCounter = 6 Then Timer1.Enabled = False

    End Sub

    Public Function P2P_ForwardOpenEventImpl(ByVal Handle As IntPtr, ByVal forwardid As Integer, ByVal forwardtype As Integer, ByVal localaddress As String, ByVal localport As Integer, ByVal remoteaddress As String, ByVal remoteport As Integer) As Boolean
        AddToList("CHANNEL on port " & P2PForward_GetLocalPort(P2P_GetForward(Handle, forwardid)) & " started")
        Return True ' allow
    End Function

    Public Sub P2P_ForwardCloseEventImpl(ByVal Handle As IntPtr, ByVal forwardid As Integer, ByVal errorno As Integer)
        Dim buffer As New StringBuilder(512)
        P2P_ErrorText(Handle, errorno, buffer)
        AddToList("CHANNEL on port " & P2PForward_GetLocalPort(P2P_GetForward(Handle, forwardid)) & " stopped " & buffer.ToString)
    End Sub

    Public Delegate Sub P2P_LinkDoneEventDelegate(ByVal Handle As IntPtr, ByVal address As String, ByVal port As Integer, ByVal errorno As Integer)
    Public Sub P2P_LinkDoneEventImpl(ByVal Handle As IntPtr, ByVal address As String, ByVal port As Integer, ByVal errorno As Integer)
        If List1.InvokeRequired Then
            List1.BeginInvoke(New P2P_LinkDoneEventDelegate(AddressOf P2P_LinkDoneEventImpl), New Object() {Handle, address, port, errorno})
        Else
            EnableButtons()
            If errorno = 0 Then
                Dim conntype As String
                Select Case P2P_GetConnectionType(Handle)
                    Case P2P_ConnectionTypes.ConnectionTCPDirect
                        conntype = "TCP"

                    Case P2P_ConnectionTypes.ConnectionTCPRelayed
                        conntype = "TCP Relayed"

                    Case P2P_ConnectionTypes.ConnectionUDPDirect
                        conntype = "UDP"

                    Case Else
                        conntype = "UNKNONW"
                End Select
                AddToList("CONNECTED " & conntype & " to " & address & " (on port " & port & ")")
                Text6.Text = ""
            Else
                Dim buffer As New StringBuilder(512)
                P2P_ErrorText(p2phandle, errorno, buffer)
                AddToList("CONNECT FAILED, " & buffer.ToString)
            End If
        End If
    End Sub

    Public Sub P2P_StoppedEventImpl(ByVal Handle As IntPtr, ByVal errorno As Integer)
        EnableButtons()
        AddToList("DISCONNECTED")
    End Sub

    Public Sub P2P_TextReceivedEventImpl(ByVal Handle As IntPtr, ByVal chanid As Integer, ByVal text As String)
        AddToList("GOT MESSAGE:")
        AddToList(text)
    End Sub

    Public Delegate Sub P2P_SearchDoneEventDelegate(ByVal Handle As IntPtr, ByVal peerName As String, ByVal peerXML As String, ByVal customData As String, ByVal errorno As Integer)
    Public Sub P2P_SearchDoneEventImpl(ByVal Handle As IntPtr, ByVal peerName As String, ByVal peerXML As String, ByVal customData As String, ByVal errorno As Integer)
        If List1.InvokeRequired Then
            List1.BeginInvoke(New P2P_SearchDoneEventDelegate(AddressOf P2P_SearchDoneEventImpl), New Object() {Handle, peerName, peerXML, customData, errorno})
        Else
            If errorno = 0 Then
                AddToList("SEARCH done, remote IP set.")
                Text6.Text = peerXML

                ' flash Connect button
                TickCounter = 0
                Timer1.Enabled = True
            Else
                Dim buffer As New StringBuilder(512)
                P2P_ErrorText(Handle, errorno, buffer)
                AddToList("SEARCH " & buffer.ToString)
            End If
        End If
    End Sub

    Public Sub P2P_StateChangeEventImpl(ByVal Handle As IntPtr, ByVal state As Integer)
        EnableButtons()
        Dim buffer As New StringBuilder(512)
        P2P_StateText(Handle, state, buffer)
        AddToList("STATE " & buffer.ToString)
    End Sub

    Public Function P2P_UserConnectedEventImpl(ByVal Handle As IntPtr, ByVal forwardid As Integer, ByVal chanid As Integer, ByVal userhandle As IntPtr) As Boolean
        Dim buffer As New StringBuilder(512)
        P2PForward_GetRemoteAddress(P2P_GetForward(Handle, forwardid), buffer)
        AddToList("USER CONNECTED " & buffer.ToString)
        Return True ' allow
    End Function

    Public Sub P2P_UserDisconnectedEventImpl(ByVal Handle As IntPtr, ByVal forwardid As Integer, ByVal chanid As Integer, ByVal userhandle As IntPtr, ByVal errorno As Integer)
        Dim buffer As New StringBuilder(512)
        P2PForward_GetRemoteAddress(P2P_GetForward(Handle, forwardid), buffer)
        AddToList("USER DISCONNECTED " & buffer.ToString)
    End Sub

    Public Sub P2P_PingEventImpl(ByVal Handle As IntPtr)
        AddToList("PING...")
    End Sub


    Public Sub btnStart_Click(ByVal sender As System.Object, ByVal ev As System.EventArgs) Handles btnStart.Click
        P2P_SetMyName(p2phandle, txtMyName.Text)
        P2P_SetPeerName(p2phandle, txtPeerName.Text)
        P2P_SetPassword(p2phandle, 1, txtPassword.Text)

        'P2P_SetVPNadapter(p2phandle, "WeOnlyDo")

        Dim e As Integer
        P2P_SetTCPPort(p2phandle, 0)
        P2P_SetUDPPort(p2phandle, 0)
        e = P2P_Start(p2phandle, P2P_Protocols.ProtoBoth)
        If (e <> 0) Then
            Dim buffer As New StringBuilder(512)
            P2P_ErrorText(Handle, e, buffer)
            MsgBox(buffer.ToString)
            EnableButtons()
        Else
            AddToList(("STARTED listening on TCP port " & P2P_GetTCPPort(p2phandle) & "  and UDP port " & P2P_GetUDPPort(p2phandle)))
            EnableButtons()
            Timer1.Enabled = True
        End If

    End Sub

    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
        Try
            P2P_Stop(p2phandle)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub btnSendFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendFile.Click
        Dim file As OpenFileDialog
        file = New OpenFileDialog()
        If (file.ShowDialog = DialogResult.OK) Then
            P2P_SendFile(p2phandle, 100, file.FileName, "newfilename", False)
        End If
    End Sub
    Public Function P2P_FileReceiveEventImpl(ByVal Handle As IntPtr, ByVal chanid As Integer, ByVal filename As String, ByVal size As Int64) As Boolean
        If List1.InvokeRequired Then
            List1.BeginInvoke(New P2P_FileReceiveEvent(AddressOf P2P_FileReceiveEventImpl), New Object() {Handle, chanid, filename, size})
        Else
            AddToList("FILE RECEIVE: " + filename + "(" + size.ToString() + " bytes)")
        End If

        Return True
    End Function
    Public Sub P2P_FileProgressEventImpl(ByVal Handle As IntPtr, ByVal chanid As Integer, ByVal position As Int64, ByVal size As Int64)
        If List1.InvokeRequired Then
            List1.BeginInvoke(New P2P_FileProgressEvent(AddressOf P2P_FileProgressEventImpl), New Object() {Handle, chanid, position, size})
        Else
            AddToList("FILE PROGRESS " + position.ToString())
        End If
    End Sub
    Public Sub P2P_FileDoneEventImpl(ByVal Handle As IntPtr, ByVal chanid As Integer, ByVal errorno As Integer)
        If List1.InvokeRequired Then
            List1.BeginInvoke(New P2P_FileDoneEvent(AddressOf P2P_FileDoneEventImpl), New Object() {Handle, chanid, errorno})
        Else
            Dim buffer As New StringBuilder(512)
            P2P_ErrorText(p2phandle, errorno, buffer)
            AddToList("FILE TRANSFER COMPLETED (" + Buffer.ToString() + ")")
        End If
    End Sub

    Public Delegate Sub Timer2_TickDelegate(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Public Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        Exit Sub
        If List1.InvokeRequired Then
            List1.BeginInvoke(New Timer2_TickDelegate(AddressOf Timer2_Tick), New Object() {sender, e})
        Else
            Do
                Dim n As Integer
                n = CInt(Math.Ceiling(Rnd() * 4))

                If btnStart.Enabled And n = 1 Then
                    btnStart_Click(sender, e)
                    Exit Sub
                End If
                If btnStop.Enabled And n = 2 Then
                    btnStop_Click(sender, e)
                    Exit Sub
                End If
                If btnSearch.Enabled And n = 3 Then
                    btnSearch_Click(sender, e)
                    Exit Sub
                End If
                If btnConnect.Enabled And n = 4 Then
                    btnConnect_Click(sender, e)
                    Exit Sub
                End If
            Loop While True
        End If
    End Sub

End Class