﻿Imports System.Text
Imports System.Runtime.InteropServices

Module devP2P

    'Const DEVP2P_DLL As String = "..\\..\\..\\..\\bin\\Windows_x86_dll\\devP2P.DLL"
    Const DEVP2P_DLL As String = "..\\..\\..\\..\\bin\\Windows_x64_dll\\devP2P.DLL"

    Enum P2P_Protocols
        ProtoTCP = 1
        ProtoUDP = 2
        ProtoBoth = 3
    End Enum

    Enum P2P_Encryptions
        EncNone = 0
        EncAES128 = 1
        EncAES192 = 2
        EncAES256 = 3
    End Enum

    Enum P2P_States
        StateStopped = 0
        StateStarted = 1
        StateSearching = 2
        StateSearchDone = 3
        StateLinking = 4
        StateConnected = 5
        StateDisconnecting = 6
        StateDisconnected = 7
    End Enum

    Enum P2P_ForwardTypes
        TCPLocalListen = 0
        TCPRemoteListen = 1
        UDPLocalListen = 2
        UDPRemoteListen = 3
        TCPSocksProxy = 4
        TCPHttpProxy = 5
    End Enum

    Enum P2P_ConnectionTypes
        ConnectionUnspecified = 0
        ConnectionTCPDirect = 1
        ConnectionUDPDirect = 2
        ConnectionTCPRelayed = 3
    End Enum

    ' create destroy
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_Create() As IntPtr
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_Destroy(ByVal Handle As IntPtr)
    End Sub

    ' properties
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_GetUDPPort(ByVal Handle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetUDPPort(ByVal Handle As IntPtr, ByVal Value As Integer)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_GetTCPPort(ByVal Handle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetTCPPort(ByVal Handle As IntPtr, ByVal Value As Integer)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_GetMediatorPort(ByVal Handle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetMediatorPort(ByVal Handle As IntPtr, ByVal Value As Integer)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_GetVersion(ByVal Handle As IntPtr, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_GetMyName(ByVal Handle As IntPtr, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetMyName(ByVal Handle As IntPtr, ByVal Value As String)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetLicenseKey(ByVal Handle As IntPtr, ByVal Value As String)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_GetPeerName(ByVal Handle As IntPtr, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetPeerName(ByVal Handle As IntPtr, ByVal Value As String)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_GetMediatorAddress(ByVal Handle As IntPtr, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetMediatorAddress(ByVal Handle As IntPtr, ByVal Value As String)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_GetRelayLicense(ByVal Handle As IntPtr, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetRelayLicense(ByVal Handle As IntPtr, ByVal Value As String)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_GetTag(ByVal Handle As IntPtr) As Object
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetTag(ByVal Handle As IntPtr, ByVal Value As Object)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_GetState(ByVal Handle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_GetConnectionType(ByVal Handle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_GetMediatorRetryDelay(ByVal Handle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetMediatorRetryDelay(ByVal Handle As IntPtr, ByVal Value As Integer)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_GetMediatorRetryCount(ByVal Handle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetMediatorRetryCount(ByVal Handle As IntPtr, ByVal Value As Integer)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_GetLinkingRetryDelay(ByVal Handle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetLinkingRetryDelay(ByVal Handle As IntPtr, ByVal Value As Integer)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_GetLinkingRetryCount(ByVal Handle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetLinkingRetryCount(ByVal Handle As IntPtr, ByVal Value As Integer)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_GetLinkingRelayDelay(ByVal Handle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetLinkingRelayDelay(ByVal Handle As IntPtr, ByVal Value As Integer)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_GetConnectionTimeout(ByVal Handle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetConnectionTimeout(ByVal Handle As IntPtr, ByVal Value As Integer)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_GetPeerAdapterIP(ByVal Handle As IntPtr, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_GetPeerAdapterMAC(ByVal Handle As IntPtr, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub

    ' methods
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_Start(ByVal Handle As IntPtr, ByVal protocol As Integer) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_Stop(ByVal Handle As IntPtr)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_Disconnect(ByVal Handle As IntPtr)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_Search(ByVal Handle As IntPtr, ByVal customdata As String) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_Link(ByVal Handle As IntPtr, ByVal peerXML As String) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_Ping(ByVal Handle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_SetPassword(ByVal Handle As IntPtr, ByVal encryption As Integer, ByVal password As String)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_SendText(ByVal Handle As IntPtr, ByVal chanid As Integer, ByVal text As String, ByVal reliable As Boolean) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_SendData(ByVal Handle As IntPtr, ByVal chanid As Integer, ByVal data As String, ByVal len As Integer, ByVal reliable As Boolean) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_SendFile(ByVal Handle As IntPtr, ByVal chanid As Integer, ByVal localfilename As String, ByVal remotefilename As String, ByVal doresume As Boolean) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_TestBandwidth(ByVal Handle As IntPtr, ByVal chanid As Integer, ByVal size As Long) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_PrintStats(ByVal Handle As IntPtr)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_GetForward(ByVal Handle As IntPtr, ByVal index As Integer) As IntPtr
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_StartForward(ByVal Handle As IntPtr, ByVal index As Integer) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_StopForward(ByVal Handle As IntPtr, ByVal index As Integer) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_BandwidthReset(ByVal Handle As IntPtr, ByVal chanid As Integer)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2P_Bandwidth(ByVal Handle As IntPtr, ByVal chanid As Integer) As Single
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_StateText(ByVal Handle As IntPtr, ByVal state As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_ErrorText(ByVal Handle As IntPtr, ByVal errorno As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub

    ' P2PForward
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2PForward_GetForwardType(ByVal ForwardHandle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2PForward_SetForwardType(ByVal ForwardHandle As IntPtr, ByVal value As Integer)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2PForward_GetLocalAddress(ByVal ForwardHandle As IntPtr, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2PForward_SetLocalAddress(ByVal ForwardHandle As IntPtr, ByVal value As String)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2PForward_GetLocalPort(ByVal ForwardHandle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2PForward_SetLocalPort(ByVal ForwardHandle As IntPtr, ByVal value As Integer)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2PForward_GetRemoteAddress(ByVal ForwardHandle As IntPtr, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2PForward_SetRemoteAddress(ByVal ForwardHandle As IntPtr, ByVal value As String)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2PForward_GetRemotePort(ByVal ForwardHandle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2PForward_SetRemotePort(ByVal ForwardHandle As IntPtr, ByVal value As Integer)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2PForward_IsOpen(ByVal ForwardHandle As IntPtr) As Boolean
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2PForward_DisconnectUser(ByVal ForwardHandle As IntPtr, ByVal UserHandle As IntPtr)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2PForwardUser_Disconnect(ByVal UserHandle As IntPtr)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function P2PForwardUser_GetTag(ByVal UserHandle As IntPtr) As Object
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2PForwardUser_SetTag(ByVal UserHandle As IntPtr, ByVal Value As Object)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_StateText(ByVal Handle As IntPtr, ByVal state As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_ErrorText(ByVal Handle As IntPtr, ByVal errorno As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub

    ' events
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub P2P_StateChangeEvent(ByVal Handle As IntPtr, ByVal state As Integer)
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub P2P_NewUPNPMappingEvent(ByVal Handle As IntPtr, ByVal ExtAddress As String, ByVal IntAddress As String, ByVal TCPPort As Integer, ByVal UDPPort As Integer)
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub P2P_SearchStartEvent(ByVal Handle As IntPtr, ByVal binds As Integer)
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub P2P_SearchDoneEvent(ByVal Handle As IntPtr, ByVal peerName As String, ByVal peerXML As String, ByVal customData As String, ByVal errorno As Integer)
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub P2P_LinkDoneEvent(ByVal Handle As IntPtr, ByVal address As String, ByVal port As Integer, ByVal errorno As Integer)
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub P2P_StoppedEvent(ByVal Handle As IntPtr, ByVal errorno As Integer)
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub P2P_TextReceivedEvent(ByVal Handle As IntPtr, ByVal chanid As Integer, ByVal text As String)
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub P2P_DataReceivedEvent(ByVal Handle As IntPtr, ByVal chanid As Integer, ByVal data As String, ByVal len As Integer)
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Function P2P_FileSendEvent(ByVal Handle As IntPtr, ByVal chanid As Integer, ByVal filename As String, ByVal size As Int64) As Boolean
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Function P2P_FileReceiveEvent(ByVal Handle As IntPtr, ByVal chanid As Integer, ByVal filename As String, ByVal size As Int64) As Boolean
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub P2P_FileProgressEvent(ByVal Handle As IntPtr, ByVal chanid As Integer, ByVal position As Int64, ByVal size As Int64)
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub P2P_FileDoneEvent(ByVal Handle As IntPtr, ByVal chanid As Integer, ByVal errorno As Integer)
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Function P2P_ForwardOpenEvent(ByVal Handle As IntPtr, ByVal forwardid As Integer, ByVal type As Integer, ByVal localaddress As String, ByVal localport As Integer, ByVal remoteaddress As String, ByVal remoteport As Integer) As Boolean
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub P2P_ForwardCloseEvent(ByVal Handle As IntPtr, ByVal forwardid As Integer, ByVal errorno As Integer)
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Function P2P_UserConnectedEvent(ByVal Handle As IntPtr, ByVal forwardid As Integer, ByVal chanid As Integer, ByVal userhandle As IntPtr) As Boolean
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub P2P_UserDisconnectedEvent(ByVal Handle As IntPtr, ByVal forwardid As Integer, ByVal chanid As Integer, ByVal userhandle As IntPtr, ByVal errorno As Integer)
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub P2P_PingEvent(ByVal Handle As IntPtr)

    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterStateChangeEvent(ByVal Handle As IntPtr, ByVal func As P2P_StateChangeEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterNewUPNPMappingEvent(ByVal Handle As IntPtr, ByVal func As P2P_NewUPNPMappingEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterSearchStartEvent(ByVal Handle As IntPtr, ByVal func As P2P_SearchStartEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterSearchDoneEvent(ByVal Handle As IntPtr, ByVal func As P2P_SearchDoneEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterLinkDoneEvent(ByVal Handle As IntPtr, ByVal func As P2P_LinkDoneEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterStoppedEvent(ByVal Handle As IntPtr, ByVal func As P2P_StoppedEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterTextReceivedEvent(ByVal Handle As IntPtr, ByVal func As P2P_TextReceivedEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterDataReceivedEvent(ByVal Handle As IntPtr, ByVal func As P2P_DataReceivedEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterFileSendEvent(ByVal Handle As IntPtr, ByVal func As P2P_FileSendEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterFileReceiveEvent(ByVal Handle As IntPtr, ByVal func As P2P_FileReceiveEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterFileProgressEvent(ByVal Handle As IntPtr, ByVal func As P2P_FileProgressEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterFileDoneEvent(ByVal Handle As IntPtr, ByVal func As P2P_FileDoneEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterForwardOpenEvent(ByVal Handle As IntPtr, ByVal func As P2P_ForwardOpenEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterForwardCloseEvent(ByVal Handle As IntPtr, ByVal func As P2P_ForwardCloseEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterUserConnectedEvent(ByVal Handle As IntPtr, ByVal func As P2P_UserConnectedEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterUserDisconnectedEvent(ByVal Handle As IntPtr, ByVal func As P2P_UserDisconnectedEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub P2P_RegisterPingEvent(ByVal Handle As IntPtr, ByVal func As P2P_PingEvent)
    End Sub


    ' VPN stuff
    ' create destroy
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function VPN_Create() As IntPtr
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_Destroy(ByVal Handle As IntPtr)
    End Sub

    ' VPN properties methods
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function VPN_GetMediatorPort(ByVal Handle As IntPtr) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_SetMediatorPort(ByVal Handle As IntPtr, ByVal Value As Integer)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_GetVersion(ByVal Handle As IntPtr, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_GetMyName(ByVal Handle As IntPtr, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_SetMyName(ByVal Handle As IntPtr, ByVal Value As String)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_SetLicenseKey(ByVal Handle As IntPtr, ByVal Value As String)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_GetMediatorAddress(ByVal Handle As IntPtr, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_SetMediatorAddress(ByVal Handle As IntPtr, ByVal Value As String)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_GetRelayLicense(ByVal Handle As IntPtr, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_SetRelayLicense(ByVal Handle As IntPtr, ByVal Value As String)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function VPN_GetTag(ByVal Handle As IntPtr) As Object
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_SetTag(ByVal Handle As IntPtr, ByVal Value As Object)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function VPN_GetState(ByVal Handle As IntPtr) As Integer
    End Function

    'VPN methods
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function VPN_Start(ByVal Handle As IntPtr, ByVal protocol As Integer) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_Stop(ByVal Handle As IntPtr)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function VPN_Search(ByVal Handle As IntPtr, ByVal peerNames As String, ByVal password As String, ByVal forever As Boolean) As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_SetAdapter(ByVal Handle As IntPtr, ByVal adapterIndex As Integer)
    End Sub

    ' events
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub VPN_StateChangeEvent(ByVal Handle As IntPtr, ByVal state As Integer)
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Function VPN_PeerConnectingEvent(ByVal Handle As IntPtr, ByVal P2PHandle As IntPtr, ByVal peerName As String, ByVal peerAddrs As String) As Integer
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub VPN_PeerConnectedEvent(ByVal Handle As IntPtr, ByVal P2PHandle As IntPtr, ByVal address As String, ByVal port As Integer)
    <UnmanagedFunctionPointer(CallingConvention.Cdecl)> Public Delegate Sub VPN_PeerDisconnectedEvent(ByVal Handle As IntPtr, ByVal P2PHandle As IntPtr, ByVal errorno As Integer)

    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_RegisterStateChangeEvent(ByVal Handle As IntPtr, ByVal func As VPN_StateChangeEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_RegisterPeerConnectingEvent(ByVal Handle As IntPtr, ByVal func As VPN_PeerConnectingEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_RegisterPeerConnectedEvent(ByVal Handle As IntPtr, ByVal func As VPN_PeerConnectedEvent)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPN_RegisterPeerDisconnectedEvent(ByVal Handle As IntPtr, ByVal func As VPN_PeerDisconnectedEvent)
    End Sub


    ' vpnadapter
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function VPNAdapter_Count() As Integer
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPNAdapter_GetName(ByVal adapterIndex As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPNAdapter_GetDriverName(ByVal adapterIndex As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPNAdapter_GetGuid(ByVal adapterIndex As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPNAdapter_GetLocalIP(ByVal adapterIndex As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPNAdapter_GetLocalNetmask(ByVal adapterIndex As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPNAdapter_GetLocalMAC(ByVal adapterIndex As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal buffer As StringBuilder)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Function VPNAdapter_GetTag(ByVal adapterIndex As Integer) As Object
    End Function
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPNAdapter_SetTag(ByVal adapterIndex As Integer, ByVal Value As Object)
    End Sub
    <DllImport(DEVP2P_DLL, CharSet:=CharSet.Ansi, CallingConvention:=CallingConvention.Cdecl)> _
    Public Sub VPNAdapter_SetIP(ByVal adapterIndex As Integer, ByVal ipaddress As String, ByVal netmask As String)
    End Sub



End Module
