#import <AudioToolbox/AudioServices.h>
#import "P2PConnectedVC.h"
#import "devP2PWrapper.h"
#import "CustomIOS7AlertView.h"


@interface P2PConnectedVC () <UIImagePickerControllerDelegate,
UINavigationControllerDelegate, CustomIOS7AlertViewDelegate>

@property (weak, nonatomic) IBOutlet UITextField *messageTextField;
@property (weak, nonatomic) IBOutlet UITextView *logTextView;
@property (nonatomic) UIImage *image;

@end

@implementation P2PConnectedVC

- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
    [mainInst setOwner:self log:_logTextView];
    AudioServicesPlayAlertSound(kSystemSoundID_Vibrate);
}

- (IBAction)sendButtonAction:(id)sender
{
    [mainInst sendMessage:[_messageTextField text]];
}

- (IBAction)sendPhotoAction:(id)sender
{
    UIImagePickerController * picker = [[UIImagePickerController alloc] init];
	picker.delegate = self;
    picker.sourceType = UIImagePickerControllerSourceTypeSavedPhotosAlbum;
    [self presentViewController:picker animated:YES completion:nil];
}

- (void)imagePickerController:(UIImagePickerController *)picker
didFinishPickingMediaWithInfo:(NSDictionary *)info
{
    [picker dismissViewControllerAnimated:YES completion:^{
        self.image = info[UIImagePickerControllerOriginalImage];
        [self sendImageConfirmationAlert:self.image];
    }];

}

- (void)sendImageConfirmationAlert:(UIImage *)image
{
    CustomIOS7AlertView *alertView = [[CustomIOS7AlertView alloc] init];
    UIView *borderView = [[UIView alloc]
                          initWithFrame:CGRectMake(0, 0, 200, 200)];
    UIImageView *imageView = [[UIImageView alloc] initWithImage:image];
    [imageView setFrame:CGRectMake(10, 10, 180, 180)];

    [borderView addSubview:imageView];

    [alertView setContainerView:borderView];
    alertView.buttonTitles = @[@"Send", @"Cancel"];
    alertView.delegate = self;
    [alertView show];
}

- (void)customIOS7dialogButtonTouchUpInside:(id)alertView
                       clickedButtonAtIndex:(NSInteger)buttonIndex
{
    [alertView close];
    if (buttonIndex == 0)
    {
        NSString *filePath = [NSTemporaryDirectory() stringByAppendingPathComponent:@"image.jpg"];
        [UIImageJPEGRepresentation(_image, 1.0) writeToFile:filePath atomically:YES];
        
        [mainInst sendFile:filePath];
        
        
/*
        NSData *data = UIImageJPEGRepresentation(_image, 1.0);
        NSFileManager *fileManager = [NSFileManager defaultManager];
        NSString *fullPath = [documentsDirectory stringByAppendingPathComponent:name];
        [fileManager createFileAtPath:fullPath contents:data attributes:nil];
        
        CGDataProviderRef provider = CGImageGetDataProvider(self.image.CGImage);
        NSString *imgName = self.image.accessibilityIdentifier;
        NSURL *url = [NSURL URLWithString:self.image];
        char *a = [url fileSystemRepresentation];
        NSData* data = (id)CFBridgingRelease(CGDataProviderCopyData(provider));
        const uint8_t* bytes = [data bytes];
*/
    }
}



@end
